/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2010 Oracle and/or its affiliates. All rights reserved.
 *
 * Oracle and Java are registered trademarks of Oracle and/or its affiliates.
 * Other names may be trademarks of their respective owners.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Oracle designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Oracle in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */
package org.netbeans.modules.css.editor;

/*
 * List of HTML5 tags. 
 * 
 * The list is generated by 
 * org.netbeans.modules.html.parser.model.ElementDescriptorTest.test_GenerateAllElementNamesArray()
 * to avoid css.editor to html.parser or html.lib dependency
 */

final public class HtmlTags {

    private static String[] tags = {
        "a", "abbr", "abs", "address", "and", "animate", "animateColor",
        "animateMotion", "animateTransform", "animation", "annotation",
        "annotation-xml", "apply", "approx", "arccos", "arccosh", "arccot",
        "arccoth", "arccsc", "arccsch", "arcsec", "arcsech", "arcsin",
        "arcsinh", "arctan", "arctanh", "area", "arg", "article", "aside",
        "audio", "b", "base", "bdo", "blockquote", "body", "br", "button",
        "bvar", "canvas", "caption", "card", "cartesianproduct", "ceiling",
        "ci", "circle", "cite", "cn", "code", "codomain", "col", "colgroup",
        "command", "complexes", "compose", "condition", "conjugate",
        "cos", "cosh", "cot", "coth", "csc", "csch", "csymbol", "curl",
        "datalist", "dd", "declare", "defs", "degree", "del", "desc",
        "details", "determinant", "dfn", "diff", "discard", "div", "divergence",
        "divide", "dl", "domain", "domainofapplication", "dt", "ellipse",
        "em", "embed", "emptyset", "encoding", "eq", "equivalent", "eulergamma",
        "exists", "exp", "exponentiale", "factorial", "factorof", "false",
        "fieldset", "figcaption", "figure", "floor", "fn", "font", "font-face",
        "font-face-src", "font-face-uri", "footer", "forall", "foreignObject",
        "form", "function", "g", "gcd", "geq", "glyph", "grad", "gt",
        "h1", "h2", "h3", "h4", "h5", "h6", "handler", "head", "header",
        "hgroup", "hkern", "hr", "html", "i", "ident", "iframe", "image",
        "imaginary", "imaginaryi", "img", "implies", "in", "infinity",
        "input", "ins", "int", "integers", "intersect", "interval", "inverse",
        "kbd", "keygen", "label", "lambda", "laplacian", "lcm", "legend",
        "leq", "li", "limit", "line", "linearGradient", "link", "list",
        "listener", "ln", "log", "logbase", "lowlimit", "lt", "maction",
        "malign", "maligngroup", "malignmark", "malignscope", "map",
        "mark", "math", "matrix", "matrixrow", "max", "mean", "median",
        "menclose", "menu", "merror", "meta", "metadata", "meter", "mfenced",
        "mfrac", "mfraction", "mglyph", "mi", "min", "minus", "missing-glyph",
        "mlabeledtr", "mmultiscripts", "mn", "mo", "mode", "moment",
        "momentabout", "mover", "mpadded", "mpath", "mphantom", "mprescripts",
        "mroot", "mrow", "ms", "mspace", "msqrt", "mstyle", "msub", "msubsup",
        "msup", "mtable", "mtd", "mtext", "mtr", "munder", "munderover",
        "naturalnumbers", "nav", "neq", "none", "noscript", "not", "notanumber",
        "notin", "notprsubset", "notsubset", "object", "ol", "optgroup",
        "option", "or", "otherwise", "outerproduct", "output", "p", "param",
        "partialdiff", "path", "pi", "piece", "piecewice", "piecewise",
        "partialdiff", "path", "pi", "piece", "piecewice", "piecewise",
        "plus", "polygon", "polyline", "power", "pre", "prefetch", "primes",
        "product", "progress", "prsubset", "q", "quotient", "radialGradient",
        "rationals", "real", "reals", "rect", "reln", "rem", "root",
        "rp", "rt", "ruby", "samp", "scalarproduct", "script", "sdev",
        "sec", "sech", "section", "select", "selector", "semantics",
        "sep", "set", "setdiff", "sin", "sinh", "small", "solidColor",
        "source", "span", "stop", "strong", "style", "sub", "subset",
        "sum", "summary", "sup", "svg", "switch", "table", "tan", "tanh",
        "tbody", "tbreak", "td", "tendsto", "text", "textArea", "textarea",
        "tfoot", "th", "thead", "time", "times", "title", "tr", "track",
        "transpose", "true", "tspan", "ul", "union", "uplimit", "use",
        "var", "variance", "vector", "vectorproduct", "video", "wbr",
        "xor" //NOI18N
    };

    /** Return the set of known tags */
    public static String[] getTags() {
        return tags;
    }
}
