/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 2013 Oracle and/or its affiliates. All rights reserved.
 *
 * Oracle and Java are registered trademarks of Oracle and/or its affiliates.
 * Other names may be trademarks of their respective owners.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Oracle designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Oracle in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 *
 * Contributor(s):
 *
 * Portions Copyrighted 2013 Sun Microsystems, Inc.
 */
package org.netbeans.modules.mercurial.ui.diff;

/**
 *
 * @author Ondrej Vrabec
 */
public class DiffToRevisionPanel extends javax.swing.JPanel {

    /**
     * Creates new form DiffToRevisionPanel
     */
    public DiffToRevisionPanel () {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        btnGrp = new javax.swing.ButtonGroup();
        lblRevisionLocalToAny = new javax.swing.JLabel();
        lblRevisionBaseToAny = new javax.swing.JLabel();

        btnGrp.add(rbLocalToBase);
        rbLocalToBase.setSelected(true);
        org.openide.awt.Mnemonics.setLocalizedText(rbLocalToBase, org.openide.util.NbBundle.getMessage(DiffToRevisionPanel.class, "DiffToRevisionPanel.localToBase.text")); // NOI18N
        rbLocalToBase.setToolTipText(org.openide.util.NbBundle.getMessage(DiffToRevisionPanel.class, "DiffToRevisionPanel.localToBase.TTtext")); // NOI18N

        btnGrp.add(rbLocalToAny);
        org.openide.awt.Mnemonics.setLocalizedText(rbLocalToAny, org.openide.util.NbBundle.getMessage(DiffToRevisionPanel.class, "DiffToRevisionPanel.rbLocalToAny.text")); // NOI18N
        rbLocalToAny.setToolTipText(org.openide.util.NbBundle.getMessage(DiffToRevisionPanel.class, "DiffToRevisionPanel.rbLocalToAny.toolTipText")); // NOI18N

        btnGrp.add(rbBaseToAny);
        org.openide.awt.Mnemonics.setLocalizedText(rbBaseToAny, org.openide.util.NbBundle.getMessage(DiffToRevisionPanel.class, "DiffToRevisionPanel.rbBaseToAny.text")); // NOI18N
        rbBaseToAny.setToolTipText(org.openide.util.NbBundle.getMessage(DiffToRevisionPanel.class, "DiffToRevisionPanel.rbBaseToAny.toolTipText")); // NOI18N

        lblRevisionLocalToAny.setLabelFor(tfSelectedRevisionLocalToAny);
        org.openide.awt.Mnemonics.setLocalizedText(lblRevisionLocalToAny, org.openide.util.NbBundle.getMessage(DiffToRevisionPanel.class, "DiffToRevisionPanel.lblRevisionLocalToAny.text")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(btnSelectLocalToAny, org.openide.util.NbBundle.getMessage(DiffToRevisionPanel.class, "DiffToRevisionPanel.btnSelectLocalToAny.text")); // NOI18N

        tfSelectedRevisionLocalToAny.setEditable(false);
        tfSelectedRevisionLocalToAny.setText(org.openide.util.NbBundle.getMessage(DiffToRevisionPanel.class, "DiffToRevisionPanel.tfSelectedRevisionLocalToAny.text")); // NOI18N

        javax.swing.GroupLayout localToRevisionPanelLayout = new javax.swing.GroupLayout(localToRevisionPanel);
        localToRevisionPanel.setLayout(localToRevisionPanelLayout);
        localToRevisionPanelLayout.setHorizontalGroup(
            localToRevisionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(localToRevisionPanelLayout.createSequentialGroup()
                .addGap(0, 0, 0)
                .addComponent(lblRevisionLocalToAny)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(tfSelectedRevisionLocalToAny)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btnSelectLocalToAny)
                .addGap(0, 0, 0))
        );
        localToRevisionPanelLayout.setVerticalGroup(
            localToRevisionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(localToRevisionPanelLayout.createSequentialGroup()
                .addGap(0, 0, 0)
                .addGroup(localToRevisionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblRevisionLocalToAny)
                    .addComponent(tfSelectedRevisionLocalToAny, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(btnSelectLocalToAny))
                .addGap(0, 0, 0))
        );

        org.openide.awt.Mnemonics.setLocalizedText(btnSelectBaseToAny, org.openide.util.NbBundle.getMessage(DiffToRevisionPanel.class, "DiffToRevisionPanel.btnSelectBaseToAny.text")); // NOI18N

        tfSelectedRevisionBaseToAny.setEditable(false);
        tfSelectedRevisionBaseToAny.setText(org.openide.util.NbBundle.getMessage(DiffToRevisionPanel.class, "DiffToRevisionPanel.tfSelectedRevisionBaseToAny.text")); // NOI18N

        lblRevisionBaseToAny.setLabelFor(tfSelectedRevisionBaseToAny);
        org.openide.awt.Mnemonics.setLocalizedText(lblRevisionBaseToAny, org.openide.util.NbBundle.getMessage(DiffToRevisionPanel.class, "DiffToRevisionPanel.lblRevisionBaseToAny.text")); // NOI18N

        javax.swing.GroupLayout baseToRevisionPanelLayout = new javax.swing.GroupLayout(baseToRevisionPanel);
        baseToRevisionPanel.setLayout(baseToRevisionPanelLayout);
        baseToRevisionPanelLayout.setHorizontalGroup(
            baseToRevisionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(baseToRevisionPanelLayout.createSequentialGroup()
                .addGap(0, 0, 0)
                .addComponent(lblRevisionBaseToAny)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(tfSelectedRevisionBaseToAny)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btnSelectBaseToAny)
                .addGap(0, 0, 0))
        );
        baseToRevisionPanelLayout.setVerticalGroup(
            baseToRevisionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(baseToRevisionPanelLayout.createSequentialGroup()
                .addGap(0, 0, 0)
                .addGroup(baseToRevisionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblRevisionBaseToAny)
                    .addComponent(tfSelectedRevisionBaseToAny, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(btnSelectBaseToAny))
                .addGap(0, 0, 0))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(rbLocalToBase)
                            .addComponent(rbLocalToAny)
                            .addComponent(rbBaseToAny))
                        .addGap(0, 170, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(21, 21, 21)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(localToRevisionPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(baseToRevisionPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(rbLocalToBase)
                .addGap(18, 18, 18)
                .addComponent(rbLocalToAny)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(localToRevisionPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(rbBaseToAny)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(baseToRevisionPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    final javax.swing.JPanel baseToRevisionPanel = new javax.swing.JPanel();
    private javax.swing.ButtonGroup btnGrp;
    final javax.swing.JButton btnSelectBaseToAny = new javax.swing.JButton();
    final javax.swing.JButton btnSelectLocalToAny = new javax.swing.JButton();
    private javax.swing.JLabel lblRevisionBaseToAny;
    private javax.swing.JLabel lblRevisionLocalToAny;
    final javax.swing.JPanel localToRevisionPanel = new javax.swing.JPanel();
    final javax.swing.JRadioButton rbBaseToAny = new javax.swing.JRadioButton();
    final javax.swing.JRadioButton rbLocalToAny = new javax.swing.JRadioButton();
    final javax.swing.JRadioButton rbLocalToBase = new javax.swing.JRadioButton();
    final javax.swing.JTextField tfSelectedRevisionBaseToAny = new javax.swing.JTextField();
    final javax.swing.JTextField tfSelectedRevisionLocalToAny = new javax.swing.JTextField();
    // End of variables declaration//GEN-END:variables
}
